src/fvm/fvm_morton.h File Reference

| programmer's documentation

- Main Page
- Related Pages
- Modules
- Data Structures
- Files

- File List
- Globals

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Data Structures | Typedefs | Enumerations | Functions
fvm_morton.h File Reference
`#include "cs_defs.h"`
`#include <stdio.h>`
`#include "fvm_defs.h"`
Include dependency graph for fvm_morton.h:

Go to the source code of this file.

## Data Structures
struct | fvm_morton_code_t

## Typedefs
typedef unsigned int | fvm_morton_int_t

## Enumerations
enum | fvm_morton_compare_t { FVM_MORTON_EQUAL_ID, FVM_MORTON_SAME_ANCHOR, FVM_MORTON_DIFFERENT_ID }

## Functions
void | fvm_morton_get_coord_extents (int dim, size_t n_coords, const cs_coord_t coords[], cs_coord_t g_extents[])
void | fvm_morton_get_global_extents (int dim, size_t n_extents, const cs_coord_t extents[], cs_coord_t g_extents[])
fvm_morton_code_t | fvm_morton_encode (int dim, fvm_morton_int_t level, const cs_coord_t coords[])
void | fvm_morton_encode_coords (int dim, fvm_morton_int_t level, const cs_coord_t extents[], size_t n_coords, const cs_coord_t coords[], fvm_morton_code_t m_code[])
void | fvm_morton_get_children (int dim, fvm_morton_code_t parent, fvm_morton_code_t children[])
fvm_morton_compare_t | fvm_morton_compare (int dim, fvm_morton_code_t code_a, fvm_morton_code_t code_b)
void | fvm_morton_local_order (cs_lnum_t n_codes, const fvm_morton_code_t morton_codes[], cs_lnum_t order[])
void | fvm_morton_local_sort (cs_lnum_t n_codes, fvm_morton_code_t morton_codes[])
_Bool | fvm_morton_a_gt_b (fvm_morton_code_t a, fvm_morton_code_t b)
_Bool | fvm_morton_a_ge_b (fvm_morton_code_t a, fvm_morton_code_t b)
int | fvm_morton_binary_search (cs_lnum_t size, fvm_morton_code_t code, fvm_morton_code_t *codes)
size_t | fvm_morton_quantile_search (size_t n_quantiles, fvm_morton_code_t code, fvm_morton_code_t *quantile_start)
void | fvm_morton_dump (int dim, fvm_morton_code_t code)

## Typedef Documentation

typedef unsigned int fvm_morton_int_t

## Enumeration Type Documentation

enum fvm_morton_compare_t

Enumerator
FVM_MORTON_EQUAL_ID |
FVM_MORTON_SAME_ANCHOR |
FVM_MORTON_DIFFERENT_ID |

## Function Documentation

_Bool fvm_morton_a_ge_b | ( | fvm_morton_code_t | a,
|  | fvm_morton_code_t | b
| ) |  |

_Bool fvm_morton_a_gt_b | ( | fvm_morton_code_t | a,
|  | fvm_morton_code_t | b
| ) |  |

int fvm_morton_binary_search | ( | cs_lnum_t | size,
|  | fvm_morton_code_t | code,
|  | fvm_morton_code_t * | codes
| ) |  |

fvm_morton_compare_t fvm_morton_compare | ( | int | dim,
|  | fvm_morton_code_t | code_a,
|  | fvm_morton_code_t | code_b
| ) |  |

void fvm_morton_dump | ( | int | dim,
|  | fvm_morton_code_t | code
| ) |  |

fvm_morton_code_t fvm_morton_encode | ( | int | dim,
|  | fvm_morton_int_t | level,
|  | const cs_coord_t | coords[]
| ) |  |

void fvm_morton_encode_coords | ( | int | dim,
|  | fvm_morton_int_t | level,
|  | const cs_coord_t | extents[],
|  | size_t | n_coords,
|  | const cs_coord_t | coords[],
|  | fvm_morton_code_t | m_code[]
| ) |  |

void fvm_morton_get_children | ( | int | dim,
|  | fvm_morton_code_t | parent,
|  | fvm_morton_code_t | children[]
| ) |  |

void fvm_morton_get_coord_extents | ( | int | dim,
|  | size_t | n_coords,
|  | const cs_coord_t | coords[],
|  | cs_coord_t | g_extents[]
| ) |  |

void fvm_morton_get_global_extents | ( | int | dim,
|  | size_t | n_extents,
|  | const cs_coord_t | extents[],
|  | cs_coord_t | g_extents[]
| ) |  |

void fvm_morton_local_order | ( | cs_lnum_t | n_codes,
|  | const fvm_morton_code_t | morton_codes[],
|  | cs_lnum_t | order[]
| ) |  |

void fvm_morton_local_sort | ( | cs_lnum_t | n_codes,
|  | fvm_morton_code_t | morton_codes[]
| ) |  |

size_t fvm_morton_quantile_search | ( | size_t | n_quantiles,
|  | fvm_morton_code_t | code,
|  | fvm_morton_code_t * | quantile_start
| ) |  |